'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Layer2 = require('../../Layer');

var _Layer3 = _interopRequireDefault(_Layer2);

var _cwise = require('cwise');

var _cwise2 = _interopRequireDefault(_cwise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * SReLU advanced activation layer class
 * S-shaped Rectified Linear Unit
 */
var SReLU = function (_Layer) {
  _inherits(SReLU, _Layer);

  /**
   * Creates a SReLU activation layer
   */
  function SReLU() {
    var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, SReLU);

    var _this = _possibleConstructorReturn(this, (SReLU.__proto__ || Object.getPrototypeOf(SReLU)).call(this, attrs));

    _this._compute = (0, _cwise2.default)({
      args: ['array', 'array', 'array', 'array', 'array'],
      body: function body(_x, tL, aL, tR, aR) {
        _x = tL + Math.min(Math.max(_x - tL, 0), Math.abs(tR)) + aL * Math.min(_x - tL, 0) + Math.max(_x - (tL + Math.abs(tR)), 0) * aR;
      }
    });

    _this.layerClass = 'SReLU';

    // Layer weights specification
    _this.params = ['t_left', 'a_left', 't_right', 'a_right'];
    return _this;
  }

  // t_right_actual = t_left + abs(t_right)
  // Y_left_and_center = t_left + K.relu(x - t_left, a_left, t_right_actual - t_left)
  // Y_right = K.relu(x - t_right_actual) * a_right
  // return Y_left_and_center + Y_right


  _createClass(SReLU, [{
    key: 'call',


    /**
     * Method for layer computational logic
     * @param {Tensor} x
     * @returns {Tensor} x
     */
    value: function call(x) {
      this._compute(x.tensor, this.weights.t_left.tensor, this.weights.a_left.tensor, this.weights.t_right.tensor, this.weights.a_right.tensor);
      return x;
    }
  }]);

  return SReLU;
}(_Layer3.default);

exports.default = SReLU;